﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace Base.BLL
{
    public interface IBaseCRUD<T>
    {
        void Add(T pEntity);

        void Delete(T pEntity);

        void Attach(T pEntity);

        void Detach(T pEntity);

        void Update(T pEntity);

        T SelectOne(Expression<Func<T, bool>> where);

        int GetCount();

        IQueryable<T> Find(Expression<Func<T, bool>> where);

        IQueryable<T> GetAll();

        IQueryable<T> GetMany(int count);

        void SaveChanges();

        IQueryable<T> GetPaging(string sortExpression, int maximumRows, int startRowIndex, Expression<Func<T, object>> order);

        IQueryable<T> GetPaging(string sortExpression, int maximumRows, int startRowIndex);

        int GetCountPaging(string sortExpression, int maximumRows, int startRowIndex);

    }
}
