
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 12/27/2010 21:36:01
-- Generated from EDMX file: C:\Users\Henrique\documents\visual studio 2010\Projects\GoodToWork\DAL\GoodToWorkEntity.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [GoodToWork];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_LocalidadeEmpresa]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Empresas] DROP CONSTRAINT [FK_LocalidadeEmpresa];
GO
IF OBJECT_ID(N'[dbo].[FK_EmpresaComentario]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Comentarios] DROP CONSTRAINT [FK_EmpresaComentario];
GO
IF OBJECT_ID(N'[dbo].[FK_EmpresaVoto_Empresa]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[EmpresaVoto] DROP CONSTRAINT [FK_EmpresaVoto_Empresa];
GO
IF OBJECT_ID(N'[dbo].[FK_EmpresaVoto_Voto]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[EmpresaVoto] DROP CONSTRAINT [FK_EmpresaVoto_Voto];
GO
IF OBJECT_ID(N'[dbo].[FK_EmpresaFuncao]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Funcoes] DROP CONSTRAINT [FK_EmpresaFuncao];
GO
IF OBJECT_ID(N'[dbo].[FK_TipoFuncaoFuncao]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Funcoes] DROP CONSTRAINT [FK_TipoFuncaoFuncao];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Empresas]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Empresas];
GO
IF OBJECT_ID(N'[dbo].[Localidades]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Localidades];
GO
IF OBJECT_ID(N'[dbo].[Comentarios]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Comentarios];
GO
IF OBJECT_ID(N'[dbo].[Votos]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Votos];
GO
IF OBJECT_ID(N'[dbo].[TipoFuncoes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TipoFuncoes];
GO
IF OBJECT_ID(N'[dbo].[Funcoes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Funcoes];
GO
IF OBJECT_ID(N'[dbo].[EmpresaVoto]', 'U') IS NOT NULL
    DROP TABLE [dbo].[EmpresaVoto];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Empresas'
CREATE TABLE [dbo].[Empresas] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Nome] nvarchar(max)  NOT NULL,
    [Morada] nvarchar(max)  NOT NULL,
    [Imagem] nvarchar(max)  NOT NULL,
    [Site] nvarchar(max)  NOT NULL,
    [Email] nvarchar(max)  NOT NULL,
    [LocalidadeId] int  NOT NULL,
    [Descricao] nvarchar(max)  NOT NULL,
    [DataCriacao] datetime  NOT NULL
);
GO

-- Creating table 'Localidades'
CREATE TABLE [dbo].[Localidades] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Nome] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Comentarios'
CREATE TABLE [dbo].[Comentarios] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [EmpresaId] int  NOT NULL,
    [Username] nvarchar(max)  NOT NULL,
    [Texto] nvarchar(max)  NOT NULL,
    [Data] datetime  NOT NULL
);
GO

-- Creating table 'Votos'
CREATE TABLE [dbo].[Votos] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Pontuacao] float  NOT NULL,
    [Data] datetime  NOT NULL,
    [Username] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'TipoFuncoes'
CREATE TABLE [dbo].[TipoFuncoes] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Nome] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Funcoes'
CREATE TABLE [dbo].[Funcoes] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [EmpresaId] int  NOT NULL,
    [TipoFuncaoId] int  NOT NULL,
    [Ordenado] float  NOT NULL,
    [TotalRaters] int  NOT NULL,
    [Qualificacoes] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'EmpresaVoto'
CREATE TABLE [dbo].[EmpresaVoto] (
    [Empresa_Id] int  NOT NULL,
    [Voto_Id] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [Id] in table 'Empresas'
ALTER TABLE [dbo].[Empresas]
ADD CONSTRAINT [PK_Empresas]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Localidades'
ALTER TABLE [dbo].[Localidades]
ADD CONSTRAINT [PK_Localidades]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Comentarios'
ALTER TABLE [dbo].[Comentarios]
ADD CONSTRAINT [PK_Comentarios]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Votos'
ALTER TABLE [dbo].[Votos]
ADD CONSTRAINT [PK_Votos]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'TipoFuncoes'
ALTER TABLE [dbo].[TipoFuncoes]
ADD CONSTRAINT [PK_TipoFuncoes]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'Funcoes'
ALTER TABLE [dbo].[Funcoes]
ADD CONSTRAINT [PK_Funcoes]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Empresa_Id], [Voto_Id] in table 'EmpresaVoto'
ALTER TABLE [dbo].[EmpresaVoto]
ADD CONSTRAINT [PK_EmpresaVoto]
    PRIMARY KEY NONCLUSTERED ([Empresa_Id], [Voto_Id] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [LocalidadeId] in table 'Empresas'
ALTER TABLE [dbo].[Empresas]
ADD CONSTRAINT [FK_LocalidadeEmpresa]
    FOREIGN KEY ([LocalidadeId])
    REFERENCES [dbo].[Localidades]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_LocalidadeEmpresa'
CREATE INDEX [IX_FK_LocalidadeEmpresa]
ON [dbo].[Empresas]
    ([LocalidadeId]);
GO

-- Creating foreign key on [EmpresaId] in table 'Comentarios'
ALTER TABLE [dbo].[Comentarios]
ADD CONSTRAINT [FK_EmpresaComentario]
    FOREIGN KEY ([EmpresaId])
    REFERENCES [dbo].[Empresas]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EmpresaComentario'
CREATE INDEX [IX_FK_EmpresaComentario]
ON [dbo].[Comentarios]
    ([EmpresaId]);
GO

-- Creating foreign key on [Empresa_Id] in table 'EmpresaVoto'
ALTER TABLE [dbo].[EmpresaVoto]
ADD CONSTRAINT [FK_EmpresaVoto_Empresa]
    FOREIGN KEY ([Empresa_Id])
    REFERENCES [dbo].[Empresas]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [Voto_Id] in table 'EmpresaVoto'
ALTER TABLE [dbo].[EmpresaVoto]
ADD CONSTRAINT [FK_EmpresaVoto_Voto]
    FOREIGN KEY ([Voto_Id])
    REFERENCES [dbo].[Votos]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EmpresaVoto_Voto'
CREATE INDEX [IX_FK_EmpresaVoto_Voto]
ON [dbo].[EmpresaVoto]
    ([Voto_Id]);
GO

-- Creating foreign key on [EmpresaId] in table 'Funcoes'
ALTER TABLE [dbo].[Funcoes]
ADD CONSTRAINT [FK_EmpresaFuncao]
    FOREIGN KEY ([EmpresaId])
    REFERENCES [dbo].[Empresas]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EmpresaFuncao'
CREATE INDEX [IX_FK_EmpresaFuncao]
ON [dbo].[Funcoes]
    ([EmpresaId]);
GO

-- Creating foreign key on [TipoFuncaoId] in table 'Funcoes'
ALTER TABLE [dbo].[Funcoes]
ADD CONSTRAINT [FK_TipoFuncaoFuncao]
    FOREIGN KEY ([TipoFuncaoId])
    REFERENCES [dbo].[TipoFuncoes]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TipoFuncaoFuncao'
CREATE INDEX [IX_FK_TipoFuncaoFuncao]
ON [dbo].[Funcoes]
    ([TipoFuncaoId]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------